function DBwrite2DCrL(DATAinsert,idElabData,ListaDate,NodeNum,IDcentralina,...
    DTcatena,Ch2DCrL,CrL2D_NTC,cont2DCrL,conn)

nNodo = num2str(NodeNum);
l = ListaDate;

for ii=1:l
    idData = idElabData(ii,1);
    tablename = 'ELABDATADISP';
    if  idData == 0 % Se la data non è su DB (=0), scrivo i dati
        if Ch2DCrL(cont2DCrL) >= 2 && CrL2D_NTC(cont2DCrL) == 1 % scrivo la T
            colnames = {'UnitName','ToolNameID','NodeNum','EventDate','EventTime',...
                'XShift','YShift','T_node','calcerr'};
            data = [DATAinsert(ii,1),DATAinsert(ii,2),DATAinsert(ii,3),...
                DATAinsert(ii,4),DATAinsert(ii,5),DATAinsert(ii,6),DATAinsert(ii,7),...
                DATAinsert(ii,8),DATAinsert(ii,9)];
        else
            colnames = {'UnitName','ToolNameID','NodeNum','EventDate','EventTime',...
                'XShift','YShift','calcerr'};
            data = [DATAinsert(ii,1),DATAinsert(ii,2),DATAinsert(ii,3),...
                DATAinsert(ii,4),DATAinsert(ii,5),DATAinsert(ii,6),DATAinsert(ii,7),...
                DATAinsert(ii,9)];
        end
        fastinsert(conn,tablename,colnames,data);
    else % altrimenti li aggiorno  
        if Ch2DCrL(cont2DCrL) >= 2 && CrL2D_NTC(cont2DCrL) == 1 % scrivo la T
           colnames = {'XShift','YShift','T_node','calcerr'};
           data = [DATAinsert(ii,6),DATAinsert(ii,7),DATAinsert(ii,8),...
               DATAinsert(ii,9)];
        else
            colnames = {'XShift','YShift','calcerr'};
            data = [DATAinsert(ii,6),DATAinsert(ii,7),DATAinsert(ii,9)];
        end
        whereclause = ['WHERE UnitName = ''' IDcentralina ''' and ToolNameID = '''...
             DTcatena ''' and NodeNum = ''' nNodo ''' and EventDate = ''' ...
             cell2mat(DATAinsert(ii,4)) ''' and EventTime = ''' cell2mat(DATAinsert(ii,5)) ''' '];
        update(conn,tablename,colnames,data,whereclause)
   end
end

end